Appicon="notepad.ico"

dim filedlg as filedialog
dim stream as filestream

Resource copys as "copy.bmp"
Resource undo as "undo.bmp"
Resource redo as "redo.bmp"

object myform as form
  center
  width=600
  object popup as popupmenu
  object pop1 as menuitem
    caption="Copy"
    BMPResource(copys)
    onclick=edit_copy
  end object
  object pop2 as menuitem
    caption="Undo"
    BMPResource(undo)
  end object
  object pop3 as menuitem
    caption="Redo"
    BMPResource(redo)
  end object
  end object
  object mymenu as mainmenu
    object file as menuitem
      caption="&File"
      object mopen as menuitem
        caption="&Open"
        onclick=file_open
      end object
      object save as menuitem
        caption="&Save"
        onclick=file_save
      end object
  object exits as menuitem
        caption="&Exit"
        onclick=file_exit
      end object  
    end object
    object medit as menuitem
      caption="&Edit" 
      object cut as menuitem
        Caption="&Cut"
        Onclick=edit_cut 
      end object
      object copy as menuitem
        Caption="&Copy"
        Onclick=edit_copy 
      end object
      object paste as menuitem
        Caption="&Paste"
        Onclick=edit_paste 
      end object
    end object
  end object
  caption="NsPad"
  object myrichedit as richedit
    align=alclient
    scrollbars=ssvertical
    hidescrollbars=false
  end object
end object

myform.showmodal

sub edit_cut
  myrichedit.cuttoclipboard
end sub

sub edit_paste
  myrichedit.pastefromclipboard
end sub

sub edit_copy
  myrichedit.copytoclipboard
end sub

sub file_open
 filedlg.show
 myform.caption=filedlg.filename
 stream.open(filedlg.filename)
 myrichedit.text=stream.read(stream.size)
 stream.close
end sub

sub file_save
  if myform.caption<>"Editor" then
    filedlg.filename=myform.caption
  end if
  filedlg.buttontext="Save"
  Filedlg.caption="Save as"
  filedlg.show
  stream.open(filedlg.filename)
  stream.write(myrichedit.text)
  stream.close     
end sub

sub file_exit(sender as menuitem)
  sender.end
end sub